// helper for tinymce, fix and extensions 2024 mirko boeer

loadJSfile( tinymce.util.URI.getDocumentBaseUrl(document.location) + 'tinymce/' + "tinymce_imageresize.js", "tinymce_imageresize", "origin", false);

function tinymce_helper_setup(editor, event){

  if(typeof editor.target.config.allow_html_data_urls !== "undefined" && editor.target.config.allow_html_data_urls == true){
     // fix for tinymce bug add ?random to data:image url, possibly not work in Safari
      var l;
      var observer = new MutationObserver(function(mutations) {
          mutations.forEach(function(mutation) {
              if (mutation.type === "attributes" && mutation.target && mutation.target.tagName == "IMG" &&
                  mutation.target.src && mutation.target.src.substr(0, 10).indexOf("data:image") == 0 &&
                  (l = mutation.target.src.lastIndexOf("?"))
                  ) {

                  if(l > -1)
                    mutation.target.src = mutation.target.src.substr(0, l);
              }

          });
      });

      let target = editor.target.dom.doc.body;
      observer.observe(target, { attributes: true, childList: false, subtree: true });
     //
  }

  if(typeof editor.target.config.newdocument_content !== "undefined" && editor.target.config.newdocument_content.trim() != "")
     editor.target.options.set("newdocument_content", editor.target.config.newdocument_content);

  // we set config as option
  if(editor.target && typeof editor.target.config !== "undefined"){
    editor.target.options.register('config', {
      processor: 'object',
      default: {}
    });
    editor.target.options.set("config", editor.target.config);
  }

  // editor.getParam return all init params, in tinymce 7 is removed, we simulate it, we need this to get all options on init
  if(typeof editor.target.getParam === "undefined"){
     editor.target.getParam = function(valueName, defaultValue){
       let editor = tinymce.activeEditor;
       let o = editor.options.get(valueName);
       if(!o || typeof o === "undefined" || o === "undefined"){
           return editor.config ? editor.config.get(valueName, defaultValue) : tinymce.defaulteditorConfig.get(valueName, defaultValue);
       }
       return o;
     }
  }

  if(typeof editor.target.config.bindModifiedEvent !== "undefined" && editor.target.config.bindModifiedEvent){
    let editor_ = editor.target;
    editor_.once('keydown', (e) => {
       editor_.config.bindModifiedEvent(e.type, editor_);
    });
    editor_.on('blur', (e) => {
       editor_.config.bindModifiedEvent(e.type, editor_);
    });
    editor_.on('Dirty', (e) => {
       editor_.config.bindModifiedEvent(e.type, editor_);
    });
  }

  var allItems = editor.target.ui.registry.getAll();

  if(typeof allItems !== "undefined"){

    // change plugin code to codemirror
    if(editor.target.plugins && editor.target.plugins.code && editor.target.plugins.codemirror && editor.target.getParam("usecodemirrorAsCodeEditor", false) === true){
      if(typeof allItems.buttons !== "undefined")
        allItems.buttons.code.onAction = allItems.buttons.codemirror.onAction;

      if(typeof allItems.menuItems !== "undefined")
        allItems.menuItems.code.onAction = allItems.menuItems.codemirror.onAction;
    }

    // change plugin template/advtemplate to my templates
    if(editor.target.plugins && typeof editor.target.plugins.template !== "undefined" && editor.target.plugins.templates){
      if(typeof allItems.buttons !== "undefined" && typeof allItems.buttons.template !== "undefined")
        allItems.buttons.template.onAction = allItems.buttons.loadtemplatesdialogdialogbutton.onAction;

      if(typeof allItems.menuItems !== "undefined" && typeof allItems.menuItems.template !== "undefined")
        allItems.menuItems.template.onAction = allItems.menuItems.mnuloadtemplatesdialog.onAction;
    }

    if(editor.target.plugins && typeof editor.target.plugins.advtemplate !== "undefined" && editor.target.plugins.templates){
      if(typeof allItems.buttons !== "undefined" && typeof allItems.buttons.advtemplate !== "undefined")
        allItems.buttons.advtemplate.onAction = allItems.buttons.loadtemplatesdialogdialogbutton.onAction;
      if(typeof allItems.buttons !== "undefined" && typeof allItems.buttons.inserttemplate !== "undefined")
        allItems.buttons.inserttemplate.onAction = allItems.buttons.loadtemplatesdialogdialogbutton.onAction;
      if(typeof allItems.buttons !== "undefined" && typeof allItems.buttons.addtemplate !== "undefined")
        allItems.buttons.addtemplate.onAction = allItems.buttons.loadtemplatesdialogdialogbutton.onAction;

      if(typeof allItems.menuItems !== "undefined" && typeof allItems.menuItems.advtemplate !== "undefined")
        allItems.menuItems.advtemplate.onAction = allItems.menuItems.mnuloadtemplatesdialog.onAction;
    }
  }

  // send bindInitEvent => on("init") editor not initalized on("SetContent") not called 1st time
  if(typeof editor.target.config.bindInitEvent !== "undefined" && editor.target.config.bindInitEvent)
     editor.target.config.bindInitEvent(editor.target);
}

function tinymce_helper_init_instance_callback(editor){
        // https://www.tiny.cloud/docs/tinymce/6/events/

        let lastCmd = "";

        editor.on('OpenWindow', (e) => {
          //console.log(`The ${e.type} command was fired.`);

          if(lastCmd == "" || lastCmd === "mceFocus"){
            // mce doesn't fire mceImage on open Image dialog
            var elements = document.querySelectorAll(".tox-dialog__title");
            if(elements.length != 1) return;
            if( elements[0].innerText.indexOf('Bild einf') == 0 || elements[0].innerText.indexOf('Insert/Edit Image') == 0 )
              lastCmd = "mceImage";
          }

          if(lastCmd == "mceLink"){
            // placeholders in link dialog
            var elements = document.querySelectorAll(".tox-form");

            if(elements.length != 1) return;

            var form = elements[0];

            if(!form || form.childNodes.length == 0) return;

            let PlaceholderItems = GetAllDefinedSWMSMLPlaceholders(editor);

            if(PlaceholderItems.length == 0) return;

            var destElement = form.childNodes[0].querySelector("[type=url]");
            if(!destElement) return;
            var destElementId = "'" + destElement.getAttribute("id") + "'";

            var updateElement = form.childNodes[1].querySelector("[type=text]");
            var updateElementId = "'" + updateElement.getAttribute("id") + "'";

            var u = getnewToken(16);
            let n = editor.getParam("language", "en") == "de" ? "Platzhalter in URL einf&uuml;gen" : "Insert placeholder in URL";
            let vn = editor.getParam("language", "en") == "de" ? "Platzhalter..." : "Placeholders...";
            let boxwidth = getComputedStyle(form.childNodes[0]).width;
            var html = '<div class="tox-form__group" aria-disabled="false"><label style="padding-top: 8px;" class="tox-label" for="form-field_' + u + '">' + n + '</label><div class="tox-listboxfield"><select size="1" style="padding-bottom: 8px; max-width: ' + boxwidth + '; width: ' + boxwidth + '" id="form-field_' + u + '" onchange="var x = (document.getElementById(' + updateElementId + ') && document.getElementById(' + updateElementId + ').value == document.getElementById(' + destElementId + ').value); InsertFieldValue(this.id, ' + destElementId + '); this.selectedIndex = 0;  if(x) document.getElementById(' + updateElementId + ').value = document.getElementById(' + destElementId + ').value;">%s</select></div></div>';

            let options = '<option value="">' + vn + '</option>';;
            for(var i=0; i<PlaceholderItems.length; i++){
              const value = HTMLEntityDecode( PlaceholderItems[i][0] );
              const name = HTMLEntityDecode( PlaceholderItems[i][1] );
              options += '<option value="' + value + '">' + name + '</option>';
            }
            html = html.replace("%s", options);

            var new_element = createElementFromHTML(html, document);

            insertAfter(form.childNodes[0], new_element);

          }

          if(lastCmd == "mceImage" || lastCmd == "mceUpdateImage"){


            var element = editor.selection.getStart();
            if( typeof defaultQRCodeImage !== "undefined" &&  element.tagName == "IMG" && element.src.indexOf(defaultQRCodeImage + '?') >= 0 ){
              e.dialog.close();
              tinymce.activeEditor.execCommand('mce_QRCode');
              return;
            }


            // checkbox in image dialog

            var elements = document.querySelectorAll("[name=SetImageAsCompleteURL]");
            if(elements.length > 0){
              elements[0].checked = false;
              return;
            }

            setTimeout(AddCheckboxToImageDialog, 1); // 1 "asynchron"


            if(editor.config.allow_html_data_urls){
              // convert image to data:image/
              var saveBtn = document.getElementsByClassName("tox-button");

              if(saveBtn.length > 0){

                var realsaveBtn;
                for(var i=0; i<saveBtn.length; i++){
                  if( saveBtn[i].classList.contains("tox-button") && saveBtn[i].classList.length == 1 ){
                     realsaveBtn = saveBtn[i];
                     break;
                  }
                }

                if(realsaveBtn){
                  var f = function(e) {
                    if(e.keyCode && e.keyCode == 9) return true;
                    var elements = document.querySelectorAll(".tox-form");
                    if(elements.length == 0) return true;
                    var form = elements[0];
                    var destElement = form.childNodes[0].querySelector("[type=url]");
                    if(!destElement) return true;

                    let convertb64 = document.getElementsByName('dataURI').length > 0 && !document.getElementsByName('dataURI')[0].disabled && document.getElementsByName('dataURI')[0].checked && (destElement.value.indexOf("http") == -1 || destElement.value.indexOf("http") > 0) && destElement.value.indexOf("userfiles") > 0 && destElement.value.indexOf("data:image") == -1;

                    if(convertb64 && window.fetch){

                      // Get the remote image as a Blob with the fetch API

                      try {
                        fetch(destElement.value)
                            .then((res) => res.blob())
                            .then((blob) => {
                                // Read the Blob as DataURL using the FileReader API
                                const reader = new FileReader();
                                reader.onloadend = () => {
                                    // Convert to Base64 string
                                    const base64 = reader.result;
                                    if(base64.indexOf("data:image") == 0) // on error it can be html
                                      destElement.value = base64;
                                };
                                reader.readAsDataURL(blob);
                            });
                      } catch (error) {
                          console.error("There has been a problem with your fetch operation:", error);
                      }
                    }

                    return true;
                  };

                  realsaveBtn.addEventListener("click", f, { capture: false, passive: true } );
                  realsaveBtn.addEventListener("mousedown", f, { capture: false, passive: true } );
                  realsaveBtn.addEventListener("keydown", f, { capture: false, passive: true } );
                  realsaveBtn.addEventListener("keyup", f, { capture: false, passive: true } );
                  realsaveBtn.addEventListener("touchend", f, { capture: false, passive: true } );
                  realsaveBtn.addEventListener("keypress", f, { capture: false, passive: true } );
                  realsaveBtn.addEventListener("focusin", f, { capture: false, passive: true } );
                }
              }
            }


          }

        });

        editor.on('CloseWindow', (e) => {
          //console.log(`The ${e.type} command was fired.`);
          lastCmd = "";
        });

        editor.on('BeforeExecCommand', (e) => {
         // console.log(`The ${e.command} command was fired (before).`);
        });

        editor.on('ExecCommand', (e) => {
          //console.log(`The ${e.command} command was fired (after).`);
          lastCmd = e.command;
        });

        editor.on('click', (e) => {
         // console.log(`The ${e.command} click command was fired.`);
        });

        editor.on('keydown', (e) => {
          if(e.keyCode == 27 && parent && parent._mdialogObj ){
             parent.closeDialog();
          }
        });

        editor.on('init', (e) => {
          if(e.target.config.bindInitEvent)
            e.target.config.bindInitEvent(e.target);
        });

        editor.on('SetContent', (e) => {
          if(e.target.config.bindInitEvent)
            e.target.config.bindInitEvent(e.target);
        });

        editor.on('dblclick', (e) => {
          //console.log(`The ${e.command} dblclick command was fired.`);
          if( typeof defaultQRCodeImage !== "undefined" &&  e.target.tagName == "IMG" && e.target.src.indexOf(defaultQRCodeImage + '?') >= 0 ){
            tinymce.activeEditor.execCommand('mce_QRCode');
            return;
          }else
            if(e.target.tagName == "IMG" && e.target.src !== ""){
               tinymce.activeEditor.execCommand('mceImage');
            }

          if(e.target.tagName == "A")
             tinymce.activeEditor.execCommand('mceLink');
          if(e.target.tagName == "TABLE")
             tinymce.activeEditor.execCommand('mceTableProps');
          if(e.target.tagName == "TR")
             tinymce.activeEditor.execCommand('mceTableRowProps');
          if(e.target.tagName == "TD")
             tinymce.activeEditor.execCommand('mceTableCellProps');
        });

        editor.on('ObjectResizeStart', (e) => {
          //console.log('Resize ' + e.target.tagName +  ' started.');
        });

        editor.on('ObjectResized', (e) => {
          //console.log('Resize ' + e.target.tagName +  ' done.');

          if( e.target.tagName !== "IMG" ) return;

          AddImageSizeChangedEventToTINYMCE(e);

        });

        editor.on('ObjectSelected', (e) => {
          if( e.target.tagName !== "IMG" ) return;

          // image drag'n drop fix, src with http(s) data-mce-src real uri
          var mce_src = e.target.getAttribute("data-mce-src");
          var src = e.target.getAttribute("src");
          if(src && mce_src && mce_src != src)
            e.target.src = mce_src;

        });
}

function AddCheckboxToImageDialog(editor){
 //tox-dialog__body-nav-item tox-tab tox-dialog__body-nav-item--active

 editor = editor || tinymce.activeEditor;

 var elements = document.querySelectorAll(".tox-form");

 if(elements.length != 1) return;

 var form = elements[0];

 if(!form || form.childNodes.length == 0) return;

 // nav items
 var nav_items = document.querySelectorAll(".tox-dialog__body-nav-item");
 if(nav_items.length > 0){ // user can disable nav items in config

   // each tab is rebuild on change nav item

   var f = function(e) {
     setTimeout(AddCheckboxToImageDialog, 1); // 1 "asynchron"
   };

   for(var i=0; i<nav_items.length; i++){
     if( !nav_items[i].getAttribute("eventSet") ){
        nav_items[i].setAttribute("eventSet", 1);

        nav_items[i].addEventListener("click", f, { capture: false, passive: true } );
        nav_items[i].addEventListener("keydown", f, { capture: false, passive: true } );
        nav_items[i].addEventListener("touchend", f, { capture: false, passive: true } );

     }
   }
   if( !CSShasClass("tox-dialog__body-nav-item--active", nav_items[0]) )   //tab with URL text field
     return;
 }

 // url field
 var destElement = form.childNodes[0].querySelector("[type=url]");
 if(!destElement) return;

 if(destElement.value.indexOf("userfiles") == 0)
   destElement.value = tinymce.activeEditor.config.basePath + destElement.value;

 var _destElementId = destElement.getAttribute("id");
 var destElementId = "'" + _destElementId + "'";
 var u = getnewToken(16);

 let n = editor.getParam("language", "en") == "de" ? "Bild als URL einf&uuml;gen (nicht mit der E-Mail versenden)" : "Insert image as URL (don't send with email)";
 let _state = "";
 let _button = "";
 let _state1 = "";
 if(document.getElementById(destElement.getAttribute("id")).value.indexOf("http") == 0)
   _state = ' checked="checked"';
 if(destElement.value !== "" && destElement.value.indexOf("userfiles") == -1)
    _state += ' disabled="disabled"';

 if(destElement.value.indexOf("data:image/") == 0 || destElement.value.indexOf("http") == 0 || (destElement.value !== "" && destElement.value.indexOf("userfiles") == -1) )
    _state1 += ' disabled="disabled"';

 if(editor.config.allow_html_data_urls)
   _button = '<label style="padding-top: 8px; cursor: pointer;" class="tox-label" for="form-field_b' + u + '"><input type="checkbox" title="DATA-URI erstellen" name="dataURI" id="form-field_b' + u + '" ' + _state1 + ' onclick="dataURIclick(this.id)">&nbsp;DATA-URI erstellen</label>';

 var html = '<div class="tox-form__group" aria-disabled="false"><label style="padding-top: 8px; cursor: pointer;" class="tox-label" for="form-field_' + u + '"><input type="checkbox" name="SetImageAsCompleteURL" id="form-field_' + u + '" tabindex="-1" ' + _state + ' onclick="SetImageAsCompleteURL(this.id, ' + destElementId + ');" x-dest-elementId=' + destElementId + '>&nbsp;' + n + '</label>' + _button + '</div>';

 var new_element = createElementFromHTML(html, document);

 insertAfter(form.childNodes[0], new_element);

 var elements = document.querySelectorAll(".tox-dialog__body-content");
 if( elements.length > 0 && !elements[0].getAttribute("sizeSet") ){
   // incr size of body to prevent scrollbar
   elements[0].style.height = (parseFloat(elements[0].style.height) + new_element.offsetHeight + 6) + 'px';
   elements[0].setAttribute("sizeSet", "1");
 }
}

function SetImageAsCompleteURL(checkBoxId, destElementId) {
  var checkBoxValue = document.getElementById(checkBoxId).checked;
  var txtURL = document.getElementById(destElementId).value;
  if(document.getElementsByName('dataURI').length > 0)
    var dataURI = document.getElementsByName('dataURI')[0];
    else
    var dataURI;

  if(document.getElementById(destElementId).value === ""){
    document.getElementById(checkBoxId).checked = false;
    if(dataURI) dataURI.disabled = true;
    return;
  }

  if(document.getElementById(destElementId).value !== "" && document.getElementById(destElementId).value.indexOf("userfiles") == -1){
    if(dataURI) dataURI.disabled = true;
    return;
  }

  if(txtURL.indexOf("data:image") == 0){
    if(dataURI) dataURI.disabled = true;
    return;
  }

  if(txtURL.indexOf("userfiles") == 0)
    txtURL = tinymce.activeEditor.config.basePath + txtURL;

  var URL = tinymce.activeEditor.baseURI.source;
  URL = URL.substr(0, URL.indexOf("/tinymce"));

  // subdomains
  var count = 0;
  var s = URL;
  while(s.lastIndexOf("/") != -1){
    s = s.substr(0, s.lastIndexOf("/"));
    count++;
  }
  if(count > 2) {
    for(var i=0;i<count-2;i++)
      URL = URL.substr(0, URL.lastIndexOf("/"));
  }

  if(checkBoxValue) {
    if(txtURL.indexOf("http:") == -1 && txtURL.indexOf("https:") == -1){
      txtURL = URL + txtURL;
      document.getElementById(destElementId).value = txtURL;
      if(dataURI) dataURI.disabled = true;
    }
  } else{
    if(txtURL.indexOf("http:") > -1 || txtURL.indexOf("https:") > -1){
      txtURL = txtURL.substr(URL.length);
      document.getElementById(destElementId).value = txtURL;
      if(dataURI) dataURI.disabled = false;
    }
  }
}

function dataURIclick(checkBoxId){
 //dataURI
}

if(typeof MutationObserver !== "undefined"){

  window.addEventListener("load", function _xload(event) {
      window.removeEventListener("load", _xload, false);

      var observer = new MutationObserver(function(mutations) {
          mutations.forEach(function(mutation) {
              if (mutation.type === "childList") {
                 // change menu background to transparent
                 if(mutation.addedNodes.length > 0 && mutation.target.className == "tox-tiered-menu" ){
                    var elements = mutation.target.querySelectorAll(".tox-collection__item-label");
                    for(var i=0; i < elements.length; i++)
                      if(elements[i].childNodes.length > 0 && elements[i].childNodes[0].nodeType != 3)
                        elements[i].childNodes[0].style.backgroundColor = "transparent";
                 }
              }

          });
      });

      let target = document.body;
      observer.observe(target, { attributes: false, childList: true, subtree: true });

  }, false);


}

